<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<app-removable
  [isHoverVisible]="isDeleted"
  [message]="'This service assembly has been removed'"
>
  <div fxFlexFill fxLayout="column" class="wrapper-content">
    <div *ngIf="serviceAssembly$ | async as sa" fxLayout="column" fxLayoutGap="20px" class="content">
      <mat-card fxFlex class="card-component-lifecycle">
        <mat-card-title class="light-bold sa-name">About {{ sa.name }}</mat-card-title>

        <mat-card-content>
          <app-message
            type="info"
            msg="Changing the state of a SA will affect its SUs."
            [isClosable]="false"
            class="info-lifecycle-sa margin-top-x1"
          ></app-message>

          <div
            fxLayout="column"
            fxLayout.gt-sm="row"
            fxLayoutAlign="center start"
            fxLayoutAlign.gt-sm="start center"
            fxLayoutGap="20px"
            class="margin-top-x2"
          >
            <div fxFlex="100" fxFlex.gt-sm="none" fxLayout="row" fxLayoutAlign="start center" class="sa-state">
              <span>{{ sa.state }}</span>

              <app-led [color]="getLedColorFromState(sa.state)" class="margin-left-x1 led-sa"></app-led>
            </div>

            <div *ngIf="sa.state" fxFlex fxLayoutGap="10px" class="list-actions-name">
              <span
                *ngFor="let possibleState of getPossibleStateActions(sa.state); trackBy:trackBySaState"
                fxFlexFill
                class="btn-state-{{ possibleState.actionName.toLowerCase() }}"
              >
                <button
                  mat-stroked-button
                  type="button"
                  color="primary"
                  (click)="changeState(sa.id, possibleState.newStateAfterAction)"
                  [disabled]="sa.isUpdatingState"
                  class="btn-change-sa-state text-upper"
                >
                  <mat-icon *ngIf="possibleState.actionName === 'Stop'">stop</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Start'">play_arrow</mat-icon>
                  <mat-icon *ngIf="possibleState.actionName === 'Unload'">remove_circle_outline</mat-icon>

                  <span>{{ possibleState.actionName }}</span>
                </button>
              </span>
            </div>
          </div>
        </mat-card-content>

        <app-message
          *ngIf="sa.errorChangeState"
          type="error"
          [msg]="sa.errorChangeState"
          [isFullWidth]="true"
          class="error-change-state"
        ></app-message>
      </mat-card>

      <mat-card fxFlex class="card-related-elements">
        <mat-card-title class="light-bold title-related-elements">Related Elements</mat-card-title>

        <ng-container>
          <mat-card-content>
            <div fxLayout="column"  fxLayout.gt-md="row" fxLayoutGap="20px">
              <div
                fxFlex
                fxFlex.gt-md="none"
                fxLayout="row"
                fxLayoutAlign="start center"
                class="margin-top-x1"
              >
                <span fxFlexFill>Services units</span>
              </div>

              <ng-container>
                <div fxLayout="column" class="service-units">
                  <div
                    fxLayout="column"
                    fxLayout.gt-md="row wrap"
                    fxLayoutGap="0"
                    fxLayoutGap.gt-md="24px"
                  >
                    <div *ngFor="let su of sa.serviceUnits; trackBy:trackBySu" class="service-unit">
                      <span
                        fxFlex="calc(25% - 24px)"
                        fxFlex.gt-md="calc(33.3% - 24px)"
                        fxLayout="row"
                        fxLayoutAlign="start center"
                      >
                        <a
                          color="primary"
                          mat-stroked-button
                          matTooltipPosition="above"
                          [routerLink]="['/workspaces', (workspaceId$ | async), 'petals', 'service-units', su.id]"
                          [ngClass]="'btn-su-' + su.id"
                        >
                          <span fxFlex class="su-name ellipsis">{{ su.name }}</span>
                        </a>

                        <app-led
                          matTooltipPosition="above"
                          [color]="getLedColorFromState(su.component.state)"
                          [matTooltip]="su.component.state"
                          class="comp-led"
                        ></app-led>

                        <a
                          mat-icon-button
                          matTooltipPosition="above"
                          [matTooltip]="su.component.name"
                          [routerLink]="['/workspaces', (workspaceId$ | async), 'petals', 'components', su.component.id]"
                          [ngClass]="'btn-component' + ' comp-' + su.component.id + ' related-su-' + su.id"
                        >
                          <mat-icon svgIcon="component" color="primary" class="icon-x3 icon-component"></mat-icon>
                        </a>
                      </span>
                    </div>
                  </div>
                </div>
              </ng-container>
            </div>
          </mat-card-content>
        </ng-container>
      </mat-card>
    </div>
  </div>
</app-removable>